unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    StartRun: TButton;
    procedure InitNecker(Sender: TObject);
    procedure mousexy(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure StartRunClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  procedure IdleLoop(Sender: TObject; var Done: boolean);

  end;

var
  Form1: TForm1;

implementation

uses math;
{$R *.dfm}
type   poly2dtype = array[1..50] of
                record
                  show: boolean;
                  x2d,y2d: double;
                 end;

type poly3dtype = array[1..16] of
                 record
                  show: boolean;
                  x3d,y3d,z3d: double;
                 end;


     poly2dptrtype = ^poly2dtype;

const initcube: poly3dtype =
                 ( (show: false; x3d: -1; y3d:-1; z3d:-1),
                  (show:true; x3d: -1; y3d:-1; z3d:1),
                  (show:true; x3d: -1; y3d:1; z3d:1),
                  (show:true; x3d: -1; y3d:1; z3d:-1),
                  (show:true; x3d: -1; y3d:-1; z3d:-1),

                  (show:true; x3d: 1; y3d:-1; z3d:-1),

                  (show:true; x3d: 1; y3d:-1; z3d:1),
                  (show:true; x3d: 1; y3d:1; z3d:1),
                  (show:true; x3d: 1; y3d:1; z3d:-1),
                  (show:true; x3d: 1; y3d:-1; z3d:-1),

                  (show:false; x3d: 1; y3d:1; z3d:-1),
                  (show:true; x3d: -1; y3d:1; z3d:-1),

                  (show:false; x3d: -1; y3d:1; z3d:1),
                  (show:true; x3d: 1; y3d:1; z3d:1),

                  (show:false; x3d: 1; y3d:-1; z3d:1),
                  (show:true; x3d: -1; y3d:-1; z3d:1)

                  );



var cube3d: poly3dtype;
    cube2d: poly2dtype;
    t1,t2,freq: int64;
    stage: smallint;
    theta, phi, mousex, mousey: double;
    x,y,z,xp,yp,zp: double;
    x1,x2,x3,y1,y2,y3,slow: double;
    errorsig: array[0..3599] of record
                              x,y,dx,dy,mx,my:integer;
                             end;
    timer,framerate: integer;
    lastframe: integer;

procedure clrscr;
begin
 with form1, canvas do
  fillrect(rect(0,0,clientwidth, clientheight));
end;

procedure projectxy(var   poly3d: poly3dtype;
                    var  poly2d: poly2dtype;
                    n: integer;
                    th1,ph1,d: double);
var i: integer;
    ca,sa: double;
    p1: poly3dtype;
    x0,y0: integer;
begin
 if th1 < -pi then th1 := th1 + 2*pi
 else
 if th1 >= pi then th1 := th1 - 2*pi;
 if ph1 < -pi then ph1 := ph1 + 2*pi
 else
 if ph1 >= 2*pi then ph1 := ph1 - 2*pi;
 x0 := round(0.5*form1.ClientWidth);
 y0 := round(0.5*form1.ClientHeight);
 for i := 1 to n do
  begin
   poly2d[i].show := poly3d[i].show;
   with poly3d[i] do
    begin
     x := 100*x3d;
     y := 100*y3d;
     z := 100*z3d;
    end;

   ca := cos(ph1); sa := sin(ph1);
   xp := ca*x + sa*z;
   zp := -sa*x + ca*z;

   x := xp; z := zp;

   ca := cos(th1); sa := sin(th1);
   yp := ca*y + sa*z;
   zp := -sa*y + ca*z;

   with p1[i] do // temporarily save rotated 3D figure
   begin
    x3d := xp;
    y3d := yp;
    z3d := zp + d;
   end;
   with poly2d[i],p1[i] do // project rotated figure into 2D
   if(z3d <> -500) then
    begin
     x2d := x0 + round(x3d); //*500/(500 + z3d));
     y2d := y0 - round(y3d); //*500/(500 + z3d));
    end;
  end;
end;

procedure drawpoly(n: integer; var v: poly2dtype);
var i: integer;
begin
 with form1.canvas do
 begin
  for i := 1 to n do
   with v[i] do
     if not show then
      moveto(round(v[i].x2d),round(v[i].y2d))
     else
      lineto(round(x2d),round(y2d));
 end;
end;

procedure movecube;
begin
 x1 := x1 + (20*(random - 0.5) - x1)/slow;
 x2 := x2 + (x1 - x2)/slow;
 x3 := x3 + (x2 - x3)/slow;
 y1 := y1 + (20*(random - 0.5) - y1)/slow;
 y2 := y2 + (y1 - y2)/slow;
 y3 := y3 + (y2 - y3)/slow;
 if stage = 1 then
  begin
   theta := y3 +  mousey;
   phi :=  x3 + mousex;
  end
  else
  begin
   theta := 0; phi := 0;
  end;
 with form1, canvas do
 begin
  pen.Width := 8;
  pen.color := clwhite;
  drawpoly(16,cube2d);
  projectxy(cube3d, cube2d,16,theta, phi, 1000);
  pen.color := clGray;
  drawpoly(16,cube2d);
  if stage = 1 then
  with errorsig[timer] do
  begin
   x := round(100*phi);
   y := round(100*theta);
   dx := round(100*x3);
   dy := round(100*y3);
   mx := round(100*mousex);
   my := round(100*mousey);
  end;
 end;
 if stage = 1 then
  begin
   if timer <= (lastframe - 1) then inc(timer);
  end
 else timer := 0;
 if timer > lastframe - 1 then stage := 2;
 end;

procedure showerror;
var i,j, base1, base2: integer;
    datafile: text;
    crlf: string[3];
    sumx, sumy: double;
begin
 crlf := chr(13) + chr(10);
 with form1, canvas do
  begin
   base1 := round(0.333*clientheight);
   base2 := round(0.667*clientheight);
   brush.color := clwhite;
   clrscr;
   pen.width := 1;
   assignfile(datafile,'NeckData.txt');
   rewrite(datafile);
   write(datafile,inttostr(lastframe),crlf);
   // find average values and subtract out of data before plotting
   sumx := 0; sumy := 0;
   for i := 0 to (lastframe - 1) do
    begin
     with errorsig[i] do
     begin
      write(datafile,
            inttostr(x),',',
            inttostr(y),',',
            inttostr(dx),',',
            inttostr(dy),',',
            inttostr(mx),',',
            inttostr(my),
            crlf);
      sumx := sumx + x;
      sumy := sumy + y;
     end;
    end;
    closefile(datafile);
    sumx := sumx/lastframe;
    sumy := sumy/lastframe;
    for i := 0 to (lastframe - 1) do
     with errorsig[i] do
     begin
      x := x - round(sumx);
      y := y - round(sumy);
      j := round(i*clientwidth/lastframe);
      pen.color := clRed;
      ellipse(rect(j-1,base1 - x-1, j+1,base1 - x+1));
      pen.color := clGreen;
      ellipse(rect(j-1,base2 - y-1, j+1,base2 - y+1));
     end;
   pen.color := clBlack;
   moveto(0,base1); lineto(clientwidth,base1);
   moveto(0,base2); lineto(clientwidth,base2);
  end;
  stage := 3;
end;

procedure iterate;
begin
 case stage of
  0: begin
      with form1, canvas do
       begin
        brush.color := clWhite;
        fillrect(rect(0,0,clientwidth,clientheight));
        timer := 0;
        panel1.Visible := true;
       end;
       movecube;
     end;
  1: movecube;
  2: showerror;
  end;
end;


procedure TForm1.IdleLoop(Sender: TObject; var Done: boolean);
begin
 done := false;
 iterate;
 repeat
  queryperformancecounter(t2);
  application.ProcessMessages;
 until t2- t1 > 10*freq div framerate;
 t1 := t2;
end;

procedure TForm1.InitNecker(Sender: TObject);
begin
 application.OnIdle := idleloop;
 queryperformancecounter(t1);
 queryperformancefrequency(freq);
 slow := 60;
 framerate := 450;
 label1.Caption :=
   'Frame Rate = ' + floattostrf(framerate/10,fffixed,4,1);
 lastframe := round(framerate*6);
 cube3d := initcube;
 timer := 0;
 //form1.cursor := crNone;
end;

procedure TForm1.mousexy(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  mousex := pi*(x - clientwidth div 2)/width;
  mousey := pi*(y - clientheight div 2)/width;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 framerate := Trackbar1.position;
 lastframe := round(framerate*6);
 label1.Caption :=
  'Frame Rate = ' + floattostrf(framerate/10,fffixed,4,1);
end;

procedure TForm1.StartRunClick(Sender: TObject);
begin
 stage := 1;
 panel1.visible := false;
 clrscr;
end;

end.
